diff --git a/package/glibc/0002-struct-stat-is-not-posix-conformant-on-microblaze-wi.patch b/package/glibc/0002-struct-stat-is-not-posix-conformant-on-microblaze-wi.patch
deleted file mode 100644
index 9797f3a935..0000000000
--- a/package/glibc/0002-struct-stat-is-not-posix-conformant-on-microblaze-wi.patch
+++ /dev/null
@@ -1,37 +0,0 @@
-From 87d415cc133ff493ccd02464c061cb171d11ef2f Mon Sep 17 00:00:00 2001
-From: "Arnout Vandecappelle (Essensium/Mind)" <arnout@mind.be>
-Date: Mon, 25 Jul 2022 11:25:15 +0200
-Subject: [PATCH] struct stat is not posix conformant on microblaze with
- __USE_FILE_OFFSET64
-
-Commit a06b40cdf5ba0d2ab4f9b4c77d21e45ff284fac7 updated stat.h to use
-__USE_XOPEN2K8 instead of __USE_MISC to add the st_atim, st_mtim and
-st_ctim members to struct stat. However, for microblaze, there are two
-definitions of struct stat, depending on the __USE_FILE_OFFSET64 macro.
-The second one was not updated.
-
-Change __USE_MISC to __USE_XOPEN2K8 in the __USE_FILE_OFFSET64 version
-of struct stat for microblaze.
-
-Upstream: https://sourceware.org/bugzilla/show_bug.cgi?id=29403
-Signed-off-by: Arnout Vandecappelle (Essensium/Mind) <arnout@mind.be>
----
- sysdeps/unix/sysv/linux/microblaze/bits/struct_stat.h | 2 +-
- 1 file changed, 1 insertion(+), 1 deletion(-)
-
-diff --git a/sysdeps/unix/sysv/linux/microblaze/bits/struct_stat.h b/sysdeps/unix/sysv/linux/microblaze/bits/struct_stat.h
-index a2787e88343..850697f4fa6 100644
---- a/sysdeps/unix/sysv/linux/microblaze/bits/struct_stat.h
-+++ b/sysdeps/unix/sysv/linux/microblaze/bits/struct_stat.h
-@@ -89,7 +89,7 @@ struct stat
-         __blksize_t             st_blksize; /* Optimal block size for I/O.  */
-         int                     __pad3;
-         __blkcnt64_t            st_blocks;  /* Number 512-byte blocks allocated.  */
--# ifdef __USE_MISC
-+# ifdef __USE_XOPEN2K8
-         /* Nanosecond resolution timestamps are stored in a format
-          * equivalent to 'struct timespec'. This is the type used
-          * whenever possible but the Unix namespace rules do not allow the
--- 
-2.35.3
-
diff --git a/package/glibc/glibc.hash b/package/glibc/glibc.hash
index 016467cd81..902c68886c 100644
--- a/package/glibc/glibc.hash
+++ b/package/glibc/glibc.hash
@@ -1,5 +1,5 @@
 # Locally calculated (fetched from Github)
-sha256  f339586a104a8e12ff44d38fb24574d2abe694ddba322404f8bc1a50f4343228  glibc-2.35-134-gb6aade18a7e5719c942aa2da6cf3157aca993fa4.tar.gz
+sha256  a35b117825e1429dc31de042463630eec8ae204db1c688689160250ea00fea71  glibc-2.36.9000-50-gf465b21b06a17e26c1af7d75603afc481ebce0f6.tar.gz
 
 # Hashes for license files
 sha256  8177f97513213526df2cf6184d8ff986c675afb514d4e68a404010521b880643  COPYING
diff --git a/package/glibc/glibc.mk b/package/glibc/glibc.mk
index 5af539ca62..a360e3f804 100644
--- a/package/glibc/glibc.mk
+++ b/package/glibc/glibc.mk
@@ -7,7 +7,7 @@
 # Generate version string using:
 #   git describe --match 'glibc-*' --abbrev=40 origin/release/MAJOR.MINOR/master | cut -d '-' -f 2-
 # When updating the version, please also update localedef
-GLIBC_VERSION = 2.35-134-gb6aade18a7e5719c942aa2da6cf3157aca993fa4
+GLIBC_VERSION = 2.36.9000-50-gf465b21b06a17e26c1af7d75603afc481ebce0f6
 # Upstream doesn't officially provide an https download link.
 # There is one (https://sourceware.org/git/glibc.git) but it's not reliable,
 # sometimes the connection times out. So use an unofficial github mirror.
diff --git a/package/localedef/localedef.mk b/package/localedef/localedef.mk
index ae4cc55f30..e57b6fdd38 100644
--- a/package/localedef/localedef.mk
+++ b/package/localedef/localedef.mk
@@ -7,7 +7,7 @@
 # Use the same VERSION and SITE as target glibc
 # As in glibc.mk, generate version string using:
 #   git describe --match 'glibc-*' --abbrev=40 origin/release/MAJOR.MINOR/master | cut -d '-' -f 2-
-LOCALEDEF_VERSION = 2.35-134-gb6aade18a7e5719c942aa2da6cf3157aca993fa4
+LOCALEDEF_VERSION = 2.36.9000-50-gf465b21b06a17e26c1af7d75603afc481ebce0f6
 LOCALEDEF_SOURCE = glibc-$(LOCALEDEF_VERSION).tar.gz
 LOCALEDEF_SITE = $(call github,bminor,glibc,$(LOCALEDEF_VERSION))
 HOST_LOCALEDEF_DL_SUBDIR = glibc